package at.jku.ssw.pi.ue08;

import at.jku.ssw.pi.Iterator;
import at.jku.ssw.pi.graph.Edge;
import at.jku.ssw.pi.graph.Edge.Kind;
import at.jku.ssw.pi.graph.Graph;
import at.jku.ssw.pi.graph.Vertex;

public class Graphs {

	public static Graph makeTransitiveHull(Graph g) {

		// Graph TO Matrix
		final int n = g.vertices.size();
		boolean[][] adj = new boolean[n][n];
		char[] values = new char[n];

		Iterator it = g.vertices.iterator();
		for (int i = 0; it.hasNext(); i++) {
			Vertex v = (Vertex) it.next();
			values[i] = v.value;
			Edge[] edges = g.getEdges(v);
			for (int k = 0; k < edges.length; k++) {
				int j = g.vertices.indexOf(edges[k].end);
				adj[i][j] = true;
				if (edges[k].kind == Kind.Undirected) {
					adj[j][i] = true;
				}
			}
		}

		System.out.println("<< Initial Graph >>");
		printMatrix(adj, values);

		// Warshall
		// TODO

		// Matrix TO Graph
		Graph newGraph = new Graph();
		// TODO

		return newGraph;
	}

	private static void printMatrix(boolean[][] adj, char[] values) {
		System.out.print("  ");
		for (char c : values) {
			System.out.print(c + " ");
		}
		System.out.println();
		for (int i = 0; i < adj[0].length; i++) {
			System.out.print(values[i] + " ");
			for (int j = 0; j < adj.length; j++) {
				System.out.print(adj[i][j] ? "1 " : "0 ");
			}
			System.out.println();
		}
	}
}